import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JFrame;

import quicktime.QTException;
import quicktime.QTSession;
import quicktime.app.view.MoviePlayer;
import quicktime.app.view.QTFactory;
import quicktime.io.OpenMovieFile;
import quicktime.io.QTFile;
import quicktime.std.StdQTConstants;
import quicktime.std.StdQTException;
import quicktime.std.clocks.TimeRecord;
import quicktime.std.image.ImageDescription;
import quicktime.std.movies.Atom;
import quicktime.std.movies.AtomContainer;
import quicktime.std.movies.AtomData;
import quicktime.std.movies.EffectsList;
import quicktime.std.movies.Movie;
import quicktime.std.movies.ParameterDialog;
import quicktime.std.movies.Track;
import quicktime.std.movies.media.Media;
import quicktime.std.movies.media.MediaHandler;
import quicktime.std.movies.media.VideoMediaHandler;
import quicktime.util.EndianOrder;
import quicktime.util.QTHandleRef;
import quicktime.util.QTUtils;

/*
 * Created on Jun 13, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
/**
 * @author yu
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class MyPlayer extends JFrame implements ActionListener, StdQTConstants{
	JButton startButton;
	JButton chButton;
	Movie movie;
	MoviePlayer player;
	
	//AtomContainer effectDescrip = null;
	int x = 6;
	//Media newMedia;
	Track srcTrack; 
	Track effectTrack;
	JComponent movieComp;
	
	public MyPlayer(File myFile){
		super("Test");
		
		
		startButton = new JButton("Start");
		startButton.addActionListener(this);
		
		chButton = new JButton("Change");
		chButton.addActionListener(this);
		
		setLocation(100,100);
		setSize(100,100);
		this.getContentPane().setLayout(new BorderLayout());
		this.getContentPane().add(startButton, BorderLayout.SOUTH);
		this.getContentPane().add(chButton, BorderLayout.NORTH);
	
			try {
				if (QTSession.isInitialized() == false) { QTSession.open(); } 
				initMovie(myFile);
			} catch (QTException e) {
				e.printStackTrace();
			}
		this.pack();
		this.setVisible(true);
	}
	
	
	void initMovie(File file) throws QTException{ 
		QTFile qtFile = new QTFile(file); 
		OpenMovieFile openFile = OpenMovieFile.asRead(qtFile);
		movie = Movie.fromFile(openFile);
		
		srcTrack = getVideoTrack();
		System.out.println(srcTrack.getDuration());
				
		
		effectTrack = movie.addTrack(movie.getBounds().getWidthF(),movie.getBounds().getHeightF(), 0);
		int refIndex = effectTrack.addReference( srcTrack, kTrackModifierReference);

		AtomContainer effectDescrip;
		//effectDescrip = createBlurEffect(15,"srca"); //OK
		effectDescrip = ParameterDialog.showParameterDialog(new EffectsList(1,1,0),pdOptionsModalDialogBox,null,null,null);
		effectDescrip.insertChild(
				//effectDescrip.getAtomType(kParentAtomIsContainer)
				new Atom(kParentAtomIsContainer), 
				kEffectSourceName,
				1, 
				0,
				EndianOrder.flipNativeToBigEndian32(QTUtils.toOSType("srca")));
		
		AtomContainer inputMap =  createInputMap(refIndex,"srca");  //OK
		ImageDescription imageDescrp = createSampleDescriptor(effectDescrip); //OK
		
		//Media 
		//Media newMedia = Media.newFromType(videoMediaType, effectTrack, movie.getTimeScale(), null);
		Media newMedia = createEffectMedia(
				srcTrack, 
				effectTrack, 
				movie.getTimeScale(),
				imageDescrp,
				effectDescrip,
				srcTrack.getOffset(), //where to insert segment
				0,  //starting point in a media
				movie.getRate(),
				inputMap);		
		
		
		
		effectTrack.insertMedia(
				srcTrack.getOffset(), 
				0, 
				newMedia.getDuration(),
				1);
		
		
		newMedia.setInputMap(inputMap);
		/*
		newMedia  = createEffectMedia(
						srcTrack, 
						effectTrack, 
						movie.getTimeScale(),
						imageDescrp,
						srcTrack.getOffset(), //where to insert segment
						0,  //starting point in a media
						movie.getRate(),
						inputMap);*/
				
		player = new MoviePlayer(movie);
		movieComp = QTFactory.makeQTJComponent(player).asJComponent();
		this.getContentPane().add(movieComp, BorderLayout.CENTER);
	}
	
	
	Media createEffectMedia(Track srcTrack, Track effectTrack, int movieTimeScale, ImageDescription imageDescrp, AtomContainer effectDescrip, int trackStart, int mediaTima, float rate, AtomContainer inputMap) throws QTException{
		Media newMedia = Media.newFromType(videoMediaType, effectTrack, movie.getTimeScale(), null);
		
		newMedia.beginEdits();
		newMedia.addSample(
				effectDescrip,
				0,
				effectDescrip.getSize(), 
				srcTrack.getDuration() - srcTrack.getOffset(),   //duration per sample 
				
				imageDescrp, 
				1, 
				0
		);
		//see http://developer.apple.com/documentation/QuickTime/APIREF/addmediasample.htm
		newMedia.endEdits();
		return newMedia;
	}
	
	
	//Create the Blur effect
	AtomContainer createBlurEffect(int ksizeVal, String sourceName) throws QTException{
		Atom parentAtom = new Atom(kParentAtomIsContainer);
		AtomContainer effectDescrip = new AtomContainer();
		
		effectDescrip.insertChild(
				parentAtom, 
				kParameterWhatName,
				kParameterWhatID,
				0,
				kBlurImageFilterType);
		
		
		effectDescrip.insertChild(
				parentAtom,
				EndianOrder.flipNativeToBigEndian32(QTUtils.toOSType("ksiz")),
				1,
				0,
				EndianOrder.flipNativeToBigEndian32(ksizeVal)
		);
		
		effectDescrip.insertChild(
				//effectDescrip.getAtomType(kParentAtomIsContainer)
				parentAtom, 
				kEffectSourceName,
				1, 
				0,
				EndianOrder.flipNativeToBigEndian32(QTUtils.toOSType(sourceName)));
		return effectDescrip;
	}
	
	
	//Return inputmap for the effect media
	AtomContainer createInputMap(int referenceIndex, String sourceName) throws QTException{
		AtomContainer inputMap = new AtomContainer(); 
		
		//(parent, new_type, new_ID, position, data)
		Atom inputAtom = inputMap.insertChild(new Atom(kParentAtomIsContainer), kTrackModifierInput, referenceIndex, 0);
		
		
		inputMap.insertChild(inputAtom,
				kTrackModifierType, 1, 0, EndianOrder.flipNativeToBigEndian32(videoMediaType));
		
		inputMap.insertChild(inputAtom,
				kEffectDataSourceType, 1, 0,
				QTUtils.toOSType(sourceName));
		return inputMap;
	}
	
	
	//Add the effect track
	Track addEffectTrack(AtomContainer inputMap, int ksizeVal){
		
		return null;
	}
	
	
	ImageDescription createSampleDescriptor(AtomContainer effectDes) throws StdQTException, QTException{
		QTHandleRef effHandle = (QTHandleRef)effectDes;
		//int theEffectType = kBlurImageFilterType; //!!!!
		int theEffectType = getEffectType(effectDes);
		ImageDescription imageDescrp = ImageDescription.forEffect(theEffectType);
		System.out.println(imageDescrp);
		
		imageDescrp.setWidth(1);
		imageDescrp.setHeight(1);
		imageDescrp.setDataSize(effectDes.getSize());
		imageDescrp.setTemporalQuality(codecNormalQuality);
		imageDescrp.setSpatialQuality(codecNormalQuality);
		
		System.out.println(imageDescrp);
		return imageDescrp;
	}

	
	
	int getEffectType(AtomContainer effectDescriptor) throws StdQTException{
		Atom effectNameAtom  = effectDescriptor.findChildByIndex_Atom( new Atom(kParentAtomIsContainer), kParameterWhatName, kParameterWhatID);
		AtomData  ad = effectDescriptor.getAtomData(effectNameAtom);
		return ad.getInt(0);
	}
	
	

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == startButton){
				try {
					movie.setTime(new TimeRecord(movie.getTimeScale(),0));
					movie.start();
				} catch (QTException e1) {
					e1.printStackTrace();
				}
		}
		else if (e.getSource() == chButton){
			x = (x+1) % 7;
			int val =  x*2 + 3;
			System.out.println(val);
			try{
				movie.removeTrack(effectTrack);
				effectTrack = movie.addTrack(movie.getBounds().getWidthF(),movie.getBounds().getHeightF(), 0);
				int refIndex = effectTrack.addReference( srcTrack, kTrackModifierReference);

				Atom parentAtom = new Atom(kParentAtomIsContainer);
				AtomContainer effectDescrip = createBlurEffect(val ,"srca"); //OK
				AtomContainer inputMap =  createInputMap(refIndex,"srca");  //OK
				ImageDescription imageDescrp = createSampleDescriptor(effectDescrip); //OK
				
				//Media 
				//Media newMedia = Media.newFromType(videoMediaType, effectTrack, movie.getTimeScale(), null);
				Media newMedia = createEffectMedia(
						srcTrack, 
						effectTrack, 
						movie.getTimeScale(),
						imageDescrp,
						effectDescrip,
						srcTrack.getOffset(), //where to insert segment
						0,  //starting point in a media
						movie.getRate(),
						inputMap);		
				
				
				
				effectTrack.insertMedia(
						srcTrack.getOffset(), 
						0, 
						newMedia.getDuration(),
						1);
				
				
				newMedia.setInputMap(inputMap);
				
				this.getContentPane().remove(movieComp);
				movieComp = QTFactory.makeQTJComponent(player).asJComponent();
				this.getContentPane().add(movieComp, BorderLayout.CENTER);
				this.pack();
				
/*				
				Atom  paramAtom = effectDescrip.findChildByIndex_Atom(new Atom(kParentAtomIsContainer), EndianOrder.flipNativeToBigEndian32(QTUtils.toOSType("ksiz")), 1);
				effectDescrip.removeAtom(paramAtom);
				System.out.println(effectDescrip.countChildrenOfType(new Atom(kParentAtomIsContainer), EndianOrder.flipNativeToBigEndian32(QTUtils.toOSType("ksiz"))));
				effectDescrip.insertChild(
						new Atom(kParentAtomIsContainer),
						EndianOrder.flipNativeToBigEndian32(QTUtils.toOSType("ksiz")),
						1,
						0,
						EndianOrder.flipNativeToBigEndian32(val)); //3,5,7,9,11,13,15   //Wert auch endian verschluesseln
				
				
				System.out.println(effectDescrip.countChildrenOfType(new Atom(kParentAtomIsContainer), EndianOrder.flipNativeToBigEndian32(QTUtils.toOSType("ksiz"))));
				
				newMedia.beginEdits();
				newMedia.addSample(
						effectDescrip,
						0,
						effectDescrip.getSize(), 
						910,   //duration per sample 
						
						createSampleDescriptor(effectDescrip), 
						1, 
						0
				);
				//see http://developer.apple.com/documentation/QuickTime/APIREF/addmediasample.htm
				newMedia.endEdits();
				
				effectTrack.insertMedia(
						0, 
						0, 
						newMedia.getDuration(),
						1);
				//movie.setTime(new TimeRecord(movie.getTimeScale(),0));
				//movie.start();
				
				
		/*	
			try
			effectDescrip.insertChild(
					new Atom(kParentAtomIsContainer),
					EndianOrder.flipNativeToBigEndian32(QTUtils.toOSType("ksiz"))
					1,
					0,
					EndianOrder.flipNativeToBigEndian32(15)); //3,5,7,9,11,13,15   //Wert auch endian verschluesseln
			*/
			} catch (QTException e1) {
				e1.printStackTrace();
			}
		}
	}
	
	
	protected Track getVideoTrack() throws StdQTException, QTException{
		System.out.println("TrackCount " + movie.getTrackCount());
		for (int i=1; i<=movie.getTrackCount(); i++){
			Track t = movie.getTrack(i);
			Media media = t.getMedia();
			
			MediaHandler handler = media.getHandler();
			System.out.println(handler.getClass());
			/*Method[] methods = handler.getClass().getDeclaredMethods();
			for (int j=0; j<methods.length; j++){
				System.out.println(methods[j]);
			}*/
			
			
			
			if (handler instanceof VideoMediaHandler) return t; 
		}
		return null;
	}
	
	
	public static void main(String[] args){
		File f = new File("test.mov");
		if (args.length>=1) 
			 f = new File(args[0]);
		else{
			 JFileChooser fc = new JFileChooser(System.getProperty("user.dir"));
			 int retVal = fc.showOpenDialog(null);
			 if (retVal == JFileChooser.APPROVE_OPTION)
			 		f = fc.getSelectedFile();
		}
		new MyPlayer(f);
	}
}
